/** ***********************  centaure.c ****************************** **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/
/*	Leverd Baptiste				Dechanet Julien		*/
/*	IMA 5I				2007/2008			*/
/************************************************************************
/       Rodriguez Loic  Quentin Lambert Davy Ribreau Cedric Vendermeersch 
/	IMA4 SA		IMA4 SC		IMA4 SA	        IMA4 SA      	
/					2012/2013			
/************************************************************************/
/*       Clement  TACHE			Liying WANG 			*/
/*	IMA4 SA				IMA4 SC		      		*/
/*					2013/2014			*/
/************************************************************************/

#include <fcntl.h>
#include <getopt.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>


#include "centaure.h"
#include "../Threads/libthrd.h"
#include "gestionKinect.h"

#define VOCALE_BIENVENUE "Bonjour, je suis le robot centaure"
#define IHM 1

short int port_web=4000;
short int port_video=3000;

//Dfinition des tubes de communication inter-process
int tubeWS[2];
int tubeIS[2];
int tubeSIHM[2];
int tubeIW[2];
int tubeDEMO[2];
int tubeKinect[2];

//variable qui indique si l'ordre a ete execut par le robot
int ordre_ok = 1;

//dfinition
char sounds[10][BUFFER_SIZE];
char images[10][BUFFER_SIZE];

//Fonction qui rappelle la syntaxe a l'utilisateur
void syntaxe(){
	printf("Syntaxe : ./centaure [-w | --portweb] <Numero du port web> [-v | --portvideo] <Numero du port video> \n");
 	exit(1);
}

int read_sounds()
{
        int i;
        FILE *fd;
	i = 0;
	char aux[BUFFER_SIZE] = "";		 

        fd = fopen(soundsfile, "r");

        while((fgets(aux, 256, fd) != (char *)0)) {
		strcpy(sounds[i], "Soundfiles/");
		strcat(sounds[i], aux);
                sounds[i][strlen(sounds[i])-1] = '\0';
		i++;
        }

	return 0;
}

int read_images()
{
 	int i;
        FILE *fd;
        i = 0;

        char aux[BUFFER_SIZE] = "";

#ifdef DEBUG
	fprintf(stdout,"Ouverture de l'image '%s'\n",imagesfile);
#endif
        fd = fopen(imagesfile, "r"); 
	if(fd==NULL){ perror("read_images.fopen"); exit(-1); }

        while((fgets(aux, 256, fd) != (char *)0)) {
                strcpy(images[i], "Images/");
                strcat(images[i], aux);
 	        images[i][strlen(images[i])-1] = '\0';
                i++;
        }

        return 0;
}


int analyseArguments(int argc, char **argv) {

	int longindex;
	int c;

	// Definition des options
	static char *optstring="p:v:";
	static const struct option longopts[]={
		{"port",1,0,'p'},
		{"video",1,0,'v'},
		{0,0,0,0}
	};

	// Analyse lexicale
	while((c=getopt_long(argc,argv,optstring,longopts,&longindex))>0)
	{
		switch(c){
		case 'p': port_web=atoi(optarg);
			  break;
		case 'v': port_video=atoi(optarg);
			  break;
		default: syntaxe();
			 break;
		}
	}
	return 0;
}

int main(int argc, char **argv){
	// tubeWS : utilis par gestionWeb.c
	// tubeIS : utilis par gestionIrc.c
	// tubeIW : non dtermin
	// Initialisation des pipes
	dire(VOCALE_BIENVENUE);

	//pipe(tubeWS);
	pipe(tubeIS);
	//pipe(tubeIW);
	//pipe(tubeDEMO);
	pipe(tubeKinect);
	#ifdef IHM
	pipe(tubeSIHM);
	#endif

	initMutex();

	// Analyse des arguments en parametre
	analyseArguments(argc,argv);

	#ifdef IHM
	read_sounds();
	read_images();
	#endif

	/**Cration des threads**/
	
	/*Threads IHM*/
	#ifdef IHM
	//creerThreadSon();
	creerThreadIhm();
	creerThreadIhmEcoute();
	#endif
	
	/*Threads Srie*/
	
	creerThreadIrc();
	creerThreadSerie();


	/*Thread Image*/
	//creerThreadServeurImage();
	
	/*Thread Web*/
	//creerThreadServeurWeb();

	lancerGestionKinect();

	//system("beep -f 800 -l 1000 &");	
	
	while(1);

	return 0;
}
