/** ******************  gestionClientImage.c ************************* **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/

#include <errno.h>
#include <fcntl.h>
#include <linux/videodev.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>

#include "gestionServeurImage.h"
#include "gestionClientImage.h"

#include "../Threads/libthrd.h"


sigset_t ens;

/*Dfinition du handler associ au signal SIGPIPE*/
void echec_send(int sig){
	printf("Signal recu : %d\n",sig);
}

void gestionClientImage(int sd){
	unsigned char my_jpeg_buf[JPEG_BUF_SIZE];
	unsigned long int my_jpeg_bytes;
	unsigned long int current_frame=0;
	
	int envoi=1;
	time_t tps_arrivee=time(NULL);
	
	char *head="HTTP/1.0 200 OK\r\nContent-Type: multipart/x-mixed-replace; boundary=--mp-boundary\r\nExpires: Thu, 19 Nov 1981 08:52:00 GMT\r\nPragma: no-cache\r\nCache-Control: no-store, no-cache\r\nX-Protocol-Version: 1\r\n";
	char *boundary="\r\n--mp-boundary\r\nContent-Type: image/jpeg\r\nContent-Length: %d\r\nX-Index: %d\r\n\r\n";
	char headbuf[1024];

	/*On prpare une image fixe*/
	char chartux[JPEG_BUF_SIZE];
	int tux=open("./Images/tux.jpg",O_RDONLY);
	int tux_size=read(tux,chartux,JPEG_BUF_SIZE);

	/*Installation du handler*/
	sigemptyset(&ens);
	sigaddset(&ens,SIGPIPE);
	struct sigaction action;
	action.sa_handler=echec_send;
	sigaction(SIGPIPE,&action,NULL);
	
	/*On vrifie que le client peut se connecter*/
	P(&mutex_nb_client);
	nb_client++;
	if(nb_client>MAX_CONNEXIONS_IMAGES)envoi=0;
	V(&mutex_nb_client);
	printf("un thread client lance, nombre de clients : %d \n",nb_client);


	if(envoi){
		if((send(sd,head,strlen(head),0))!=-1){							/*On envoie l'en-tte HTTP*/
			while((time(NULL)-tps_arrivee)<TEMPS_MAXI_CLIENT)				/*Tant que le delai client n'est pas expir*/
			{
				P(&mutex_jpeg_buf);
				memcpy(my_jpeg_buf,jpeg_buf,JPEG_BUF_SIZE);				/*On rcupre le jpeg*/
				my_jpeg_bytes=jpeg_bytes;						/* et sa taille*/
				V(&mutex_jpeg_buf);
				
				snprintf(headbuf,sizeof(headbuf),boundary,my_jpeg_bytes,current_frame);
				if((send(sd,headbuf,strlen(headbuf),0))==-1) break;			/*On envoie une en-tte pour l'image*/
				if((send(sd,my_jpeg_buf,JPEG_BUF_SIZE,0))==-1) break;			/*On envoie l'image*/
				current_frame++;
				usleep(100000);
			}
			snprintf(headbuf,sizeof(headbuf),boundary,tux_size,current_frame);
			send(sd,headbuf,strlen(headbuf),0);
			send(sd,chartux,JPEG_BUF_SIZE,0);						/*On envoie l'image fixe*/
			send(sd,"\r\n--mp-boundary--\r\n",19,0);
		}
	}
	send(sd,chartux,JPEG_BUF_SIZE,0);
	close(sd);
	printf("On quitte un thread clientImage, ");
	P(&mutex_nb_client);
	nb_client--;
	V(&mutex_nb_client);
	printf("nombre de clients restants: %d\n",nb_client);
	pthread_exit(0);
}
