/** *******************  gestionIhmEcoute.c ************************** **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/
/*    	clement  TACHE			Liying WANG			*/ 
/*	IMA4 SA				IMA4 SC		      		*/
/*					2013/2014			*/
/************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <termios.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>

#include "centaure.h"
#include "gestionSerie.h"
#include "gestionIhm.h"
#include "gestionSon.h"
#include "gestionWeb.h"

int i = 1;
int test_image = 0;

int test_image_file(char *filename){

	if ((pixImage = gdk_pixbuf_new_from_file(filename, NULL)) != NULL) 
                return 1;
        else  {
		printf("DEBUG : gestionIhmEcoute: Fichier %s non trouv !\n", filename);
	        return 0;
	      }
}


void load(char *filename){;

    /* Appel de l'image et affichage */
	test_image = test_image_file(filename);

	if(test_image) {    
	    pixImage = gdk_pixbuf_new_from_file(filename, NULL);
	    pixScaled = gdk_pixbuf_scale_simple (pixImage, IMAGE_WT, IMAGE_HT,GDK_INTERP_BILINEAR);
	    gtk_image_set_from_pixbuf (GTK_IMAGE(image),pixScaled);    
    	}
	else	printf("Image non trouve !\n");
}
	
    

/* Fonction qui regarde si une donne est prsente sur le tubeSIHM et l'affiche sur le label */
int gestionIhmEcoute() {     
    
  char buffer[BUFFER_SIZE];
  int n;	
	
  fd_set ens;
  struct timeval tv;
  
  while(1) {
  
  /* Initialisation des donnes*/
  bzero(buffer, BUFFER_SIZE);
 
   
   #ifdef DEBUG
     printf("\nDEBUG : gestionIhm: BOUCLE \n");
   #endif
	   
   /* Creation de l'ensemble et ajout des deux entres*/		
   FD_ZERO(&ens);
   FD_SET(tubeSIHM[0],&ens);
   /* Definition de l'interval de temps */	
   tv.tv_sec = 5;
   tv.tv_usec = 0;   
   
   if (select(tubeSIHM[0]+1,&ens, NULL, NULL, &tv) == -1){
     perror("ERREUR : gestionIhm: SELECT\n");
    }
   else {
     if(FD_ISSET(tubeSIHM[0], &ens)){  
	
	#ifdef DEBUG
	  printf("DEBUG : FD_ISSET [ok]");   
	#endif

	if((n=read(tubeSIHM[0],buffer,BUFFER_SIZE))!=0){ 
	 #ifdef DEBUG
	   printf("DEBUG : gestionIhm: DONNEE SUR TUBEWS : %s \n",buffer);
	 #endif	 
	 if(buffer!=NULL) {
     	   if(strcmp(buffer,MSG_T1_TRUE)==0) {
	     load(images[6]);
	     gtk_entry_set_text (GTK_ENTRY(label), buffer);
	     gestionSon(sounds[3]);
	   }
     	   if(strcmp(buffer,MSG_T2_TRUE)==0) {
	     load(images[6]);
	     gtk_entry_set_text (GTK_ENTRY (label), buffer); 	   
             gestionSon(sounds[3]);
	   }
     	   if(strcmp(buffer,MSG_T3_TRUE)==0) {
	     load(images[6]);
	     gtk_entry_set_text (GTK_ENTRY (label), buffer); 	   
             gestionSon(sounds[3]);
	   }
     	   if(strcmp(buffer,MSG_T1_FALSE)==0) {
	     load(images[0]);
	     gtk_entry_set_text (GTK_ENTRY (label), buffer); 	   
             gestionSon(sounds[1]);
	   }
     	   if(strcmp(buffer,MSG_T2_FALSE)==0) {
             load(images[0]);
             gtk_entry_set_text (GTK_ENTRY (label), buffer);
             gestionSon(sounds[1]);
	   }
     	   if(strcmp(buffer,MSG_T3_FALSE)==0) {
             load(images[0]);
             gtk_entry_set_text (GTK_ENTRY (label), buffer);
             gestionSon(sounds[1]);
	   }
	   if(strcmp(buffer,MSG_US_TRUE)==0) {
             load(images[6]);
             gtk_entry_set_text (GTK_ENTRY (label), buffer);
             gestionSon(sounds[3]);
	   } 
	   if(strcmp(buffer,MSG_US_FALSE)==0) {
             load(images[0]);
             gtk_entry_set_text (GTK_ENTRY (label), buffer);
             gestionSon(sounds[1]);
	   } 
	   if(strcmp(buffer,AVANCER)==0) {
	     load(images[1]);
             gtk_entry_set_text (GTK_ENTRY (label), "AVANCER");
	     gestionSon(sounds[2]);
           }
           if(strcmp(buffer,RECULER)==0) {  
	     load(images[2]); 
             gtk_entry_set_text (GTK_ENTRY (label), "RECULER");
             gestionSon(sounds[2]);
           }
           if(strcmp(buffer,GAUCHE)==0) {
             load(images[3]);
             gtk_entry_set_text (GTK_ENTRY (label), "GAUCHE");
             gestionSon(sounds[2]);
           }
           if(strcmp(buffer,DROITE)==0) {
             load(images[4]);
             gtk_entry_set_text (GTK_ENTRY (label), "DROITE");
             gestionSon(sounds[2]);
           }
           if(strcmp(buffer,ARRET)==0)	{
             load(images[5]);
             gtk_entry_set_text (GTK_ENTRY (label), "ARRET");
             gestionSon(sounds[2]);
           }
	 }
       }
     }
   } 
 }   
    gtk_widget_show_all(window);
    return 0;
}
