/** **********************  gestionIrc.c ***************************** **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/
/*	Leverd Baptiste 			Dechanet julien		*/
/*	IMA 5I				2007/2008			*/
/************************************************************************
    Rodriguez Loic  Quentin Lambert Davy Ribreau Cedric Vendermeersch 
	IMA4 SA		IMA4 SC		IMA4 SA	        IMA4 SA      	
					2012/2013			
/************************************************************************/
/*   	clement  TACHE			Liying WANG 			*/
/*	IMA4 SA				IMA4 SC		      		*/
/*					2013/2014			*/
/************************************************************************/

#include <errno.h>
#include <getopt.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <termios.h>
#include <unistd.h>

#include "gestionIrc.h"
#include "irman.h"
#include "centaure.h"

#include "../Threads/libthrd.h"

#define PORTCOMM1 "/dev/ttyUSB0"	

int gestionIrc() {
	bool toucheAttribue;
	int fdIR, i, dataIR, commande;
	char cmdPipe[16];

	errno = 0;  
	if ((fdIR = ir_open_port(PORTCOMM1)) < 0) {
	fprintf(stderr, "unable to open port `%s' (%s)\n", PORTCOMM1, ir_strerror(errno));
	return 1;
	}

	/* read garbage */
	while ((dataIR = ir_read_char(IR_GARBAGE_TIMEOUT)) >= 0);
	errno = 0;
	ir_write_char('I'); putchar('I');
	tcdrain(fdIR);
	ir_usleep(IR_HANDSHAKE_GAP);
	ir_write_char('R'); putchar('R');
	putchar('\n');
	if (errno) {
		fprintf(stderr, "error writing handshake (%s)\n", ir_strerror(errno));
	}
	
	errno = 0;
	while ((dataIR = ir_read_char(IR_HANDSHAKE_TIMEOUT)) != 'O') {
		if (dataIR < 0) {
			fprintf(stderr, "error reading handshake (%s)\n", ir_strerror(errno));
			exit(1);
		} else {
			putchar(dataIR);
			putchar('!');
			fflush(stdout);
		}
	}
	putchar('O'); fflush(stdout);
	
	errno = 0;
	dataIR = ir_read_char(IR_HANDSHAKE_TIMEOUT);
	if (dataIR < 0) {
		fprintf(stderr, "error reading handshake (%s)\n", ir_strerror(errno));
		exit(1);
	} else {
		putchar(dataIR);
		if (dataIR != 'K') putchar('!');
	}
	putchar('\n');
	while(1){
		commande = 0;
		for (i=0; i<IR_CODE_LEN; i++) {
			dataIR = ir_read_char(IR_BLOCKING);
			if (dataIR < 0) {
				fprintf(stderr, "error reading data: `%s'\n", ir_strerror(errno));
				errno = 0;
			}
			/* le sixime code reu permet de diffrencier les touches utilises*/
			if(i==5) commande = dataIR;
		}
		toucheAttribue = true;	// RAZ
		switch(commande){
			case 9 : printf("\ngestionIrc : stop");write(tubeSIHM[1],ARRET,ARRET_SIZE);strcpy(cmdPipe, CMD_PIPE_STOP); break;
			case 201 : printf("\ngestionIrc : avance"); write(tubeSIHM[1],AVANCER,AVANCER_SIZE);strcpy(cmdPipe, CMD_PIPE_AVANCER);break;
			case 73 : printf("\ngestionIrc : reculer"); write(tubeSIHM[1],RECULER,RECULER_SIZE);strcpy(cmdPipe, CMD_PIPE_RECULER);break;
			case 169 : printf("\ngestionIrc : droite 45"); strcpy(cmdPipe, CMD_PIPE_DROITE_45);break;
			case 41 : printf("\ngestionIrc : gauche 45"); strcpy(cmdPipe, CMD_PIPE_GAUCHE_45);break;
 			case 189 : printf("\ngestionIrc : On quitte\n"); strcpy(cmdPipe, QUITTER);
				   ir_close_port();
				   system("/sbin/halt");
				   break;
			case 181: printf("\ngestionIrc : kinect on/off"); strcpy(cmdPipe, CMD_PIPE_KINECT_ON_OFF); break;
			case 239: printf("\ngestionIrc : demi tour"); strcpy(cmdPipe, CMD_PIPE_DEMI_TOUR); break;
			case 37:printf("\ngestionIrc : avance rapide"); strcpy(cmdPipe, CMD_PIPE_AVANCER_RAPIDE); break;
			case 165:printf("\ngestionIrc : reculer rapide"); strcpy(cmdPipe, CMD_PIPE_RECULER_RAPIDE); break;
			case 101:printf("\ngestionIrc : gauche 90"); strcpy(cmdPipe, CMD_PIPE_GAUCHE_90); break;
			case 213:printf("\ngestionIrc : droite 90"); strcpy(cmdPipe, CMD_PIPE_DROITE_90); break;
			case 25:printf("\ngestionIrc : courbe gauche"); strcpy(cmdPipe, CMD_PIPE_COURGE_G); break;
			case 147:printf("\ngestionIrc : courbe droite"); strcpy(cmdPipe, CMD_PIPE_COURGE_D); break;
			default : printf("\ngestionIrc : Commande non valide no=%d",commande); toucheAttribue=false; break;
		}
		if(toucheAttribue) {
			write(tubeIS[1], cmdPipe, CMD_PIPE_SIZE);
			//write(tubeKinect[1], cmdPipe, CMD_PIPE_SIZE);
			putchar('\n');
		}
	}
}
