/** ********************  gestionSerie.cpp *************************** **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/
/*	Leverd Baptiste 			Dechanet Julien		*/
/*	IMA 5I				2007/2008			*/
/************************************************************************
    Rodriguez Loic  Quentin Lambert Davy Ribreau Cedric Vendermeersch 
	IMA4 SA		IMA4 SC		IMA4 SA	        IMA4 SA      	
					2012/2013			
/************************************************************************/
/*    	clement  TACHE			Liying WANG 			*/
/*	IMA4 SA				IMA4 SC		      		*/
/*					2013/2014			*/
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <termios.h>

#include "centaure.h"
#include "gestionSerie.h"
#include "gestionWeb.h"
#include "gestionIrc.h"


// Definition du port serie  utiliser
#define PORTCOMM2 "/dev/ttyACM0"


#define VOCALE_KINECT_A "Kinect activ"
#define VOCALE_KINECT_D "Kinect dsactiv"
#define VOCALE_ARRET_URGENCE "Arret d'urgence"


/* Variables necessaire pour le port serie */
struct termios oldtio,newtio;
int fdSerie, ack_ok=1;
int cpt = 0;
char ordrePrecedent=0;
extern bool guidageKinectActif;
bool arretUrgence = false;
bool ordreProvenanceKinect = false;
int nbSecondeSleep;

static void initSerie(){
	/* ouvre le port en mode non-bloquant (read retourne immediatement) */
	fdSerie = open(PORTCOMM2, O_RDWR | O_NOCTTY);
	//if (fdSerie <0) {perror(PORTCOMM2);exit(-1);}
	tcgetattr(fdSerie,&oldtio); /* sauvegarde de la configuration courante */
	
	/*valeur pour lecture non canonique : on reoit tjrs le meme nbre de bits */
	
	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR;
	newtio.c_oflag = 0;
	
	/* positionne le mode de lecture (non canonique, sans echo, ...) */
	newtio.c_lflag = 0;
	
	newtio.c_cc[VTIME] = 0;
	newtio.c_cc[VMIN] = 1;	/*read bloquant*/
	
	tcflush(fdSerie, TCIFLUSH);
	tcsetattr(fdSerie,TCSANOW,&newtio);
}



static int analyseOrdreSerie(char ordre) {

	// Analyse de la commande recu par le port serie
		
	if(ordre==CMD_SERIE_BAT_100){
		printf("\n========== Batteries a pleine ==========\n");
	}
	else if(ordre==CMD_SERIE_BAT_75){
		printf("\n========== Batteries a 75/100 ==========\n");
	}
	else if(ordre==CMD_SERIE_BAT_50){
		printf("\n========== Batteries a 50/100 ==========\n");
	}
	else if(ordre==CMD_SERIE_BAT_25){
		printf("\n========== Batteries a 25/100 ==========\n");
	}
	else if(ordre==CMD_SERIE_BAT_10){
		printf("\n========== Batteries basses ==========\n");
	}
	else if(ordre==CMD_SERIE_BAT_5){
		printf("\n\n\n========== Batteries tres basse !!!!!!!! ==========\nArreter le robot sous peine d'endommager les batteries !!\n\n\n");
	}
	else if(ordre==CMD_SERIE_ARRET_URGENCE){
		printf("\n\nArret d'urgence envoye par l'arduino !\n");
		dire(VOCALE_ARRET_URGENCE);
		arretUrgence = true;
		//if(nbSecondeSleep!=0) sleep(nbSecondeSleep);	// ligne de test
	}
	else return -1;
	
	return 1;
}

/* Fonction qui analyse la chaine recu sur les tubes IS, WS et IW*/
static int analyseOrdre(char ordre[]) {
	bool envoyerOrdreDeblocage = false;
	char c;
	int i=1;
	cpt++;

	ack_ok=1;	// ack toujours ok
	
	if(strncmp(ordre,CMD_PIPE_AVANCER,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: AVANCER\n");
		#endif 
		dire("avancer"); 		
		c=CMD_SERIE_AVANCER;
	}
	else if(strncmp(ordre,CMD_PIPE_AVANCER_RAPIDE,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: AVANCER RAPIDE\n");	
		#endif
		dire("avancer rapide");	  		
		c=CMD_SERIE_AVANCER_RAPIDE;
	}
	else if(strncmp(ordre,CMD_PIPE_RECULER,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: RECULER\n");		
		#endif  		
		dire("Reculer");
		c=CMD_SERIE_RECULER;
	}
	else if(strncmp(ordre,CMD_PIPE_RECULER_RAPIDE,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: RECULER RAPIDE\n");
		dire("Reculer rapide");
		#endif  		
		c=CMD_SERIE_RECULER_RAPIDE;
	}
	else if(strncmp(ordre,CMD_PIPE_GAUCHE_90,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: GAUCHE 90\n");
		dire("Cauche");
		#endif  		
		c=CMD_SERIE_GAUCHE_90;
	}
	else if(strncmp(ordre,CMD_PIPE_GAUCHE_45,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: GAUCHE 45\n");
		#endif  		
		c=CMD_SERIE_GAUCHE_45;
	}
	else if(strncmp(ordre,CMD_PIPE_DROITE_90,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: DROITE 90\n");
		dire("Droite");
		#endif  		
		c=CMD_SERIE_DROITE_90;
	}
	else if(strncmp(ordre,CMD_PIPE_DROITE_45,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: DROITE 45\n");
		#endif  		
		c=CMD_SERIE_DROITE_45;
	}
	else if(strncmp(ordre,CMD_PIPE_DEMI_TOUR,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: DEMI TOUR\n");
		#endif  		
		c=CMD_SERIE_DEMI_TOUR;
	}
	else if(strncmp(ordre,CMD_PIPE_STOP,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: STOP\n");
		#endif  
		dire("Stop");	 
		c=CMD_SERIE_STOP;
	}
	else if(strncmp(ordre,CMD_PIPE_KINECT_ON_OFF,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: Kinect on/off\n");
		#endif
		guidageKinectActif = !guidageKinectActif;
		printf("\n========== Guidage Kinect : %d ==========\n", guidageKinectActif);
		if(guidageKinectActif) dire(VOCALE_KINECT_A);
		else dire(VOCALE_KINECT_D);
	}
	else if(strncmp(ordre,CMD_PIPE_COURGE_G,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: courbe gauche\n");
		#endif
		c=CMD_SERIE_COURBE_G;
	}
	else if(strncmp(ordre,CMD_PIPE_COURGE_D,CMD_PIPE_SIZE )==0){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: courbe droite\n");
		#endif
		c=CMD_SERIE_COURBE_D;
	}
			
	else i=-1;
	
	envoyerOrdreDeblocage = (cpt==7) & ordreProvenanceKinect;
	// Envoi de l'ordre sur le port srie
	#ifdef DEBUG
	printf("ack_ok : %d\n, ordrePrecedent : %d\n, c : %d\n, envoyerOrdreDeblocage : %d\n",ack_ok,ordrePrecedent,c,envoyerOrdreDeblocage);
	#endif

	if((ack_ok && (int)ordrePrecedent!=(int)c )|| envoyerOrdreDeblocage){
		
		printf("ordrePrecedent : %c %d   ordre courant : %c %d\n", ordrePrecedent, ordrePrecedent, c, c);
		write(fdSerie,&c,1);
		ordrePrecedent = c;		// stockage de l'ordre	
		//RAZ	
		ack_ok=0;
		arretUrgence = false;
		ordreProvenanceKinect = false;
		cpt = 0;
	}
	else if(ordrePrecedent==c){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: l'ordre recu est identique au precedent, aucun ordre ne sera envoye a l'arduino\n");
		#endif
	}
	else if(!ack_ok){
		#ifdef DEBUG    
		printf("DEBUG : gestionSerie:analyseOrdre: aucun accuse de reception n'a ete recu, aucun ordre ne sera envoye a l'arduino\n");
		#endif
	}
	
	return i;
}

/* Fonction qui recupere une chaine se terminant par END_COMMANDE='\n' sur le port serie */
/* Elle place les deux premiers caract dans commande et le reste dans parameters */
// utilis dans les projets antrieurs  2013
static void lectureSerie(char commande[]) {
	int n=0,i=0;
	char c;
	char reception[BUFFER_SIZE];
	boolean end_reception=FAUX;
	
	/* Initialisation des variables */
	bzero(reception,BUFFER_SIZE);
	
	#ifdef DEBUG  
	printf("DEBUG : gestionSerie:lectureSerie: ENTREE \n");
	#endif
	
	if((n=read(fdSerie,&c,1))==1){
		#ifdef DEBUG  	
		printf("DEBUG : gestionSerie:lectureSerie: CARACTERE LU : %c\n",c);
		#endif   
		reception[i]=c;
		while(!end_reception){
			i++;
			if((n=read(fdSerie,&c,1))==1)
			if(c==END_COMMANDE)
			end_reception=VRAI;		
			reception[i]=c;
		
			//#ifdef DEBUG  	
			printf("DEBUG : gestionSerie:lectureSerie: CARACTERE LU : %c\n",c);
			//#endif
		}
				
		#ifdef DEBUG
		printf("DEBUG : gestionSerie:lectureSerie: FIN RECEPTION\n");
		printf("DEBUG : gestionSerie:lectureSerie: RECU : %s\n",reception);
		#endif
		
		/* Copie de la commande dans la chaine commande */
		commande[0]=reception[0];
		commande[1]=reception[1];
		commande[2]='\0';
		#ifdef DEBUG
		printf("DEBUG : gestionSerie:lectureSerie: COMMANDE : %s\n",commande);	
		#endif
	}
}

void gestionSerie() {

	char commande[COMMANDE_SIZE];
	char parameters[BUFFER_SIZE];
	char buffer[BUFFER_SIZE];
	int n;	
	char c;

	fd_set ens;
	struct timeval tv;

	/* Initialisation des donnes */
	bzero(buffer, BUFFER_SIZE);

	/* Initialisation du port srie */
	initSerie();
	
	sleep(3);
	printf("\n\nVeuillez entrer le nombre de seconde de sleep lors d'un arret d'urgence, 0 desactive le sleep \n\n");
	scanf("%d", &nbSecondeSleep);
        int max=max(tubeWS[0],max(tubeIS[0],max(tubeKinect[0],max(fdSerie,max(tubeIW[0],tubeDEMO[0])))));

	while(1) {

		/* Initialisation des buffers */
		bzero(buffer, BUFFER_SIZE);
		bzero(commande,COMMANDE_SIZE);
		bzero(parameters,BUFFER_SIZE);	  

		#ifdef DEBUG
		printf("\nDEBUG : gestionSerie: BOUCLE \n");
		#endif

		/* Creation de l'ensemble et ajout des deux entres*/		
		FD_ZERO(&ens);
		FD_SET(tubeWS[0],&ens);
		FD_SET(tubeIS[0],&ens);
		FD_SET(tubeKinect[0],&ens);
		FD_SET(fdSerie,&ens);
		FD_SET(tubeIW[0],&ens);
		FD_SET(tubeDEMO[0],&ens);
		/* Definition de l'interval de temps */	
		tv.tv_sec = 5;
		tv.tv_usec = 0;	
		/* On attend qu'une donne se presente sur l'un des 4 descripteur */	  
		if (select(max+1,&ens, NULL, NULL, &tv) == -1) perror("ERREUR : gestionSerie: SELECT\n");
		else {

			if(FD_ISSET(tubeWS[0], &ens)) {
				if((n=read(tubeWS[0],buffer,BUFFER_SIZE))!=0){ 
					#ifdef DEBUG
					printf("DEBUG : gestionSerie: DONNEE SUR TUBEWS : %s \n",buffer);
					#endif	      
					if((n=analyseOrdre(buffer))<0) printf("ERREUR : gestionSerie: ORDRE WEB INCONNU \n");
				}	
			} 
			else if(FD_ISSET(tubeKinect[0], &ens)) {
				if((n=read(tubeKinect[0],buffer,BUFFER_SIZE))!=0){ 
					#ifdef DEBUG
					printf("DEBUG : gestionSerie: DONNEE SUR tubeKinect : %s \n",buffer);
					#endif	      
					ordreProvenanceKinect = true;
					if((n=analyseOrdre(buffer))<0) printf("ERREUR : gestionSerie: ORDRE KINECT INCONNU \n");
				}	
			} 
			else if(FD_ISSET(tubeIS[0], &ens)) {
				#ifdef DEBUG
				printf("TUBES[1] isset\n");
				#endif
				if((n=read(tubeIS[0],buffer,BUFFER_SIZE))!=0){ 
					#ifdef DEBUG
					printf("DEBUG : gestionSerie: DONNEE SUR TUBEIS : %s \n",buffer);
					#endif
					if((n=analyseOrdre(buffer))<0) printf("ERREUR : gestionSerie: ORDRE IRDA INCONNU\n");
				}
			}
			else if(FD_ISSET(fdSerie, &ens)) {
			
				#ifdef DEBUG 		
				printf("DEBUG : gestionSerie: DONNEE SUR PORT SERIE \n");
				#endif
				lectureSerie(commande);
				printf("recu par port serie = %s\n",commande);
				
				if((n=read(fdSerie,&c,1))!=0){ 
					#ifdef DEBUG
					printf("DEBUG : gestionSerie: donnees sur le port serie (%d octet lu) : caractere:%c  decimal:%d   hexa:%x\n", n, c, c, c);
					#endif
					if((n=analyseOrdreSerie(c))<0) printf("ERREUR : gestionSerie: Message venant de l'arduino inconnu\n");
				}	
			}
			else if(FD_ISSET(tubeIW[0], &ens)) {
				if((n=read(tubeIW[0],buffer,BUFFER_SIZE))!=0){ 
					#ifdef DEBUG
					printf("DEBUG : gestionSerie: DONNEE SUR TUBEIW : %s \n",buffer);
					#endif
					if((n=analyseOrdre(buffer))<0) printf("ERREUR : gestionSerie: ORDRE WIFI INCONNU\n");
				}
			}	
			else if(FD_ISSET(tubeDEMO[0], &ens)) {
				if((n=read(tubeDEMO[0],buffer,BUFFER_SIZE))!=0){ 
					#ifdef DEBUG
					printf("DEBUG : gestionSerie: DONNEE SUR TUBEDEMO : %s \n",buffer);
					#endif
					printf(" ordre recu: %s",buffer);
					write(fdSerie,buffer,5);
				}
			}	
			else {       
				#ifdef DEBUG  
				printf("DEBUG : gestionSerie: aucune autre donnees recu\n");
				#endif 
			}   
		}    
	}
}
