/** ***********************  gestionSon.h **************************** **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/

#ifndef gestionSon_h
#define gestionSon_h

#define AUDIO_DEVICE "/dev/audio"

/* Default audio parameters */
#define DEFAULT_BITS     16
#define DEFAULT_SPEED    44100
#define DEFAULT_CHANNELS 2

/* Audio memory pool. 512k is the default. */
#define AUDIO_BUFFER_SIZE    0x80000 

/* The minimum and maximum buffer block sizes. */
#define MIN_BLOCK_SIZE 4096
#define MAX_BLOCK_SIZE 0x10000

#define ULAW_BITS      1
#define ALAW_BITS      2
#define ADPCM_BITS     4
#define LIN8_BITS      8
#define LIN_BITS       16

/* The maximum retry count for buffer fill tries. */
#define RETRY_COUNT 5

/* Magics. Little-endian. */
#define RIFF_MAGIC    0x46464952 /* ASCII: 'RIFF' */
#define WAVE_MAGIC    0x45564157 /* ASCII: 'WAVE' */
#define DATA_MAGIC    0x61746164 /* ASCII: 'data' */
#define INFO_MAGIC    0x4f464e49 /* ASCII: 'INFO' */

/* File types */
#define UNKNOWN_FILE  0
#define RIFF_FILE     1
#define SUN_FILE      2

typedef unsigned char byte;
typedef unsigned long DWORD;
typedef unsigned short WORD;



struct info_struct {
  byte *buffer;                /* the audio data */
  byte *firstblock;            /* pointer to the first block */
  long readcount, writecount;
  int alldone;
  int skip;
  double sseconds;
  unsigned int skip_size;      /* size to skip */
  int in_seconds;
  double seconds;
  int blocksize;               /* size of one block */
  int buffer_size;             /* size of the buffer */
  int number_of_blocks;
  int last_block;              /* -1 if not the last block */
  int bytes_on_last_block;
  int writeblock;
  int swap;
  int forceraw;
  int force;
  int filetype;
  int headerskip;
  int audioset;
  int show_usage;
  int speed;
  int channels;
  int bits;
  int encoding;
  int audio_fd;                /* Audio device descriptor */
  int file_fd;                 /* Audio file descriptor */
  char *progname;
  char *device;                /* Audio device name */
  int loop;
  int verbose;
  int optind;
  int capacity;
  int framesize;
  int framecount;
  unsigned long data_length;   /* number of bytes in the data segment */
  int player;
};

void gestionSon(char *file);
#endif
