/** ***********************  gestionWeb.c **************************** **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/

#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <stdlib.h>
#include <signal.h>

#include <sys/types.h>
#include <sys/socket.h>

#include "centaure.h"
#include "gestionServeurWeb.h"
#include "gestionWeb.h"
#include "../Socket/libsck.h"
#include "../Threads/libthrd.h"

/* Fonction qui permet de generer un code de SIZE caractere MAJUSCULE */
int createCode(char *chaine, int size) {
	int i,alea;
	
	// Initialisation de RAND_MAX avec la fonction time
	srand(time(NULL));      
	for(i=0;i<size;i++) {
		// Generation d'un nombre alatoire entre 1 et 35
		alea = (int)(26*1.0*rand()/(RAND_MAX+1.0));
			chaine[i]=(char)((int)'A'+alea);
	}
	chaine[i+1]='\0';
	chaine[i+2]='\n';
	return 0;
}

// Fonction qui permet de recuperer le code et la commande recu par
// la socket et separes par le delimiteur delim
int cutOrdre(char *chaine, char delim, char *coded, char * ordre) {
	char *p;
	
	if(chaine==NULL){
		#ifdef DEBUG
		printf("DEBUG : gestionWeb:cutOrdre : CHAINE NULLE\n");
		#endif	 
		return -1;
	}
	else {
		strcpy(coded,chaine);
	
		p=strchr(coded,delim);
		if(p==NULL){
		coded[0]='\0';
		}
		else {
			strcpy(ordre,p+1);
			*(p)='\0';
			#ifdef DEBUG
			printf("DEBUG : gestionWeb:cutOrdre : CODE : %s\n",coded);
			printf("DEBUG : gestionWeb:cutOrdre : COMMANDE :  %s\n",ordre);	   
			#endif
		}
		return 1;
	}
}

int gestionWeb(int sd) {
	char msg[BUFFER_SIZE];
	char commande[BUFFER_SIZE];
	char coderecu[BUFFER_SIZE];
	char buff[BUFFER_SIZE];
	
	FILE * fsd=fdopen(sd,"r+");
	
	/* Initialisation des buffers*/
	bzero(&msg, BUFFER_SIZE);
	bzero(&commande,BUFFER_SIZE);
	bzero(&coderecu,BUFFER_SIZE);
	
	// Affichage d'un message d'accueil
	fprintf(fsd,"Bienvenue dans la partie commande du CENTAURE\n");
	fflush(fsd);

	//Si la chaine recue par la socket n'est pas null
	if(fgets(buff,BUFFER_SIZE,fsd)!=NULL){
		sscanf(buff,"%s",msg);
		strcpy(msg, buff);	// ligne de test, car le sscanf est sans doute inutile
		#ifdef DEBUG
		printf("DEBUG : gestionWeb: RECU SUR WEB : %s  ; buffer: %s \n", msg, buff);
		#endif	  

		//Si on recoit le mot cl connect
		if (strncmp(msg,CONNECT,CONNECT_SIZE)==0){
			P(&mutex_web);
			if(nbconnexion<1) {
				nbconnexion=1;
				V(&mutex_web);
				connexion=VRAI;
				#ifdef DEBUG
					printf("DEBUG : gestionWeb: RECU CONNECT PAS D'AUTRE CONNEXION\n");
				#endif		 
				//On genere le code alatoire sur CODE_SIZE caractere MAJUSCULE
				if(createCode(code,CODE_SIZE)!=0){
					printf("ERREUR : gestionWeb:createCode : ERREUR CREATION CODE\n");
					P(&mutex_web);
					nbconnexion=0;
					V(&mutex_web);
				}
				else{
					#ifdef DEBUG
					printf("DEBUG : gestionWeb: ENVOI DU CODE SUR LA SOCKET : %s\n",code);
					#endif
					fprintf(fsd,"%s",code);
					fflush(fsd);
				}
			}
			else {
				V(&mutex_web);
				//code={"F","U","L","L","L","L","\0","\n"};
				*code = "FULLLL\0\n";
				/*Si une personne est dej connect on affiche un message d'erreur*/
				#ifdef DEBUG
					printf("DEBUG : gestionWeb: RECU CONNECT ET AUTRE CONNEXION\n");
					printf("DEBUG : gestionWeb: FERMETURE SOCKET\n");
				#endif
			}
		}     
		/* Si on recoit une commande differente */
		else {
			if(cutOrdre(msg,':',coderecu,commande)<1){
				printf("ERREUR : gestionWeb:cutOrdre : \n");
				#ifdef DEBUG
				//printf("CODERECU : %s\n",coderecu);
//				printf("COMMANDE : %s\n",commande);
				#endif
			}
			else{
				char chaine[BUFFER_SIZE];
				//if((connexion==VRAI)&&(strncmp(code,coderecu,CODE_SIZE)==0)){
				connexion = true;
				if((connexion==VRAI)){	// le projet 2013 a supprim le systme de code et codeRecu, en effet ce systme n'tait pas fiable
					if(strncmp(commande,CMD_PIPE_AVANCER,CMD_PIPE_SIZE)==0){
							if(write(tubeWS[1], CMD_PIPE_AVANCER,CMD_PIPE_SIZE)!=CMD_PIPE_SIZE) printf("ERREUR : gestionWeb: WRITE\n");
					}
					if(strncmp(commande,CMD_PIPE_RECULER,CMD_PIPE_SIZE)==0){
							if(write(tubeWS[1], CMD_PIPE_RECULER,CMD_PIPE_SIZE)!=CMD_PIPE_SIZE) printf("ERREUR : gestionWeb: WRITE\n");
					}
					else if(strncmp(commande,CMD_PIPE_GAUCHE_45,CMD_PIPE_SIZE)==0){
							if(write(tubeWS[1], CMD_PIPE_GAUCHE_45,CMD_PIPE_SIZE)!=CMD_PIPE_SIZE) printf("ERREUR : gestionWeb: WRITE\n");
					}
					else if(strncmp(commande,CMD_PIPE_DROITE_45,CMD_PIPE_SIZE)==0){
							if(write(tubeWS[1], CMD_PIPE_DROITE_45,CMD_PIPE_SIZE)!=CMD_PIPE_SIZE) printf("ERREUR : gestionWeb: WRITE\n");
					}
					else if(strncmp(commande,CMD_PIPE_STOP,CMD_PIPE_SIZE)==0){
							if(write(tubeWS[1], CMD_PIPE_STOP,CMD_PIPE_SIZE)!=CMD_PIPE_SIZE) printf("ERREUR : gestionWeb: WRITE\n");
					}
					else if(strncmp(commande,CMD_PIPE_COURGE_G,CMD_PIPE_SIZE)==0){
							if(write(tubeWS[1], CMD_PIPE_COURGE_G,CMD_PIPE_SIZE)!=CMD_PIPE_SIZE) printf("ERREUR : gestionWeb: WRITE\n");
					}
					else if(strncmp(commande,CMD_PIPE_COURGE_D,CMD_PIPE_SIZE)==0){
							if(write(tubeWS[1], CMD_PIPE_COURGE_D,CMD_PIPE_SIZE)!=CMD_PIPE_SIZE) printf("ERREUR : gestionWeb: WRITE\n");
					}
					else if(strncmp(commande,CMD_PIPE_KINECT_ON_OFF,CMD_PIPE_SIZE)==0){
							if(write(tubeWS[1], CMD_PIPE_KINECT_ON_OFF,CMD_PIPE_SIZE)!=CMD_PIPE_SIZE) printf("ERREUR : gestionWeb: WRITE\n");
					}
					else if(strncmp(commande,"txt",CMD_PIPE_SIZE)==0){	// si la commande est une chaine prfix par txt, alors on souhaite effectuer une synthese vocale sur la chaine		
							#ifdef DEBUG
							printf("DEBUG : synthese vocale de la phrase : %s\n", commande+CMD_PIPE_SIZE);
							#endif
							dire(commande+CMD_PIPE_SIZE);	// on synthetise la phrase sans tenir compte du prefixe "txt", d'o le +CMD_PIPE_SIZE
					}
					else if(strncmp(commande,DECONNECT,DECONNECT_SIZE)==0){
							P(&mutex_web);
								nbconnexion=0;
							V(&mutex_web);
							connexion=FAUX;
							#ifdef DEBUG
							printf("DEBUG : gestionWeb: DECONNEXION\n");
							#endif
					}
					else printf("ERREUR : gestionWeb: COMMANDE INCONNUE\n");					
					
				}
				else printf("ERREUR : gestionWeb: COMMANDE IMPOSSIBLE\n");
			}
		}
		#ifdef DEBUG
		printf("DEBUG : gestionWeb: FERMETURE SOCKET\n");
		#endif
		fclose(fsd);
		close(sd);
	}
	return 0;
}
