/** ************************  libsck.c ******************************* **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/


#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netdb.h>
#include <string.h>
#include <arpa/inet.h>

#include "../Threads/libthrd.h"


// Fonction d'initialsation du serveur
int initialisationServeur(short int *port,int connexions) {

	int df;
	struct sockaddr_in adresse;
	int statut;
	socklen_t taille=sizeof adresse;

	// Creation d'une socket
	df=socket(PF_INET,SOCK_STREAM,0);
	if(df<0){
        	perror("\n InitialisationServeur.socket : [ECHEC] \n");
        	exit(-1);
        }

	// On fixe l'adresse de la socket
	adresse.sin_family=AF_INET;
	adresse.sin_addr.s_addr=INADDR_ANY;
	adresse.sin_port=htons(*port);
	statut=bind(df,(struct sockaddr *)&adresse,sizeof(adresse));
	if(statut<0)
		return -1;

	// On recupere le numero du port utilise
	statut=getsockname(df,(struct sockaddr *)&adresse,&taille);
	if(statut<0){
        	perror("\n initialisationServeur.getsockname : [ECHEC] \n");
        	exit(-1);
        }
	*port=ntohs(adresse.sin_port);

	// Initialisation de l'ecoute
	statut=listen(df,connexions);
	if(statut<0)
		return -1;
	return df;
}

// Fonction d'ecoute sur le socket et lancement de la fonction traitement  chaque connexion
int boucleServeur(int ecoute,void (*traitement)(int)) {
	struct sockaddr_in adresse;
	socklen_t taille=sizeof adresse;
	int dialogue;
	while(1){
		// Attente d'une connexion
		dialogue=accept(ecoute,(struct sockaddr *)&adresse,&taille);
		if(dialogue<0)
			return -1; 
		// Passage de la socket de dialogue a la fonction de traitement	
		traitement(dialogue);
	}
	return 0;
}

/*
int socketVersNom(int connexion, char * nom_machine) {

	struct sockaddr_in adresse;
	struct hostent *host;
	int taille=sizeof adresse;

	if(getpeername(connexion,(struct sockaddr *)&adresse, &taille)<0){
		perror("\n socketVersNom.getpeername : [ECHEC]\n");
		return -1;
	}
	#ifdef DEBUG
		printf("\n DEBUG : socketVersNom.getpeername : [OK]\n");
	#endif

	host = gethostbyaddr(&adresse.sin_addr.s_addr, sizeof(adresse.sin_addr), adresse.sin_family);

	#ifdef DEBUG
		printf("\n DEBUG : socketVersNom.gethostbyaddr : [OK]\n");
	#endif

	if(host==NULL){
		#ifdef DEBUG
			printf("\n DEBUG : socketVersNom : host == NULL\n");
		#endif

		strcpy(nom_machine, inet_ntoa(adresse.sin_addr));
	}
	else {
		#ifdef DEBUG
			printf("\n DEBUG : socketVersNom host =! NULL\n");
		#endif

		strncpy(nom_machine, host->h_name, 100);
	}

	#ifdef DEBUG
		printf("\n DEBUG : socketVersNom : Nom Machine : %s\n", nom_machine);
	#endif
	
	return 0;
}
*/






