/** ************************  libthrd.c ****************************** **/
/*  Fouquet Jeremy	   Lefebvre Yann	Chevalier Henri		*/
/*	IMA 3I				2004/2005			*/
/************************************************************************/
/*	Adrian Siminiceanu			Liviu Amarfei		*/
/*	USM Suceava Roumanie		2005/2006			*/
/************************************************************************/
/*	Chamfroy Florent			Gourisse Maxime		*/
/*	IMA 3I				2005/2006			*/
/************************************************************************/
/*      Leverd Baptiste                         Dechanet Julien         */
/*      IMA 5I                          2007/2008                       */
/************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#include "libthrd.h"

#include "../Demon/centaure.h"
#include "../Demon/gestionIrc.h"
#include "../Demon/gestionSerie.h"
#include "../Demon/gestionServeurWeb.h"
#include "../Demon/gestionWeb.h"
#include "../Demon/gestionKinect.h"
#include "../Demon/gestionIhm.h"
#include "../Demon/gestionIhmEcoute.h"
#include "../Demon/gestionSon.h"
#ifdef IHM
#include "../Demon/gestionCaptureImage.h"
#include "../Demon/gestionServeurImage.h"
#include "../Demon/gestionClientImage.h"
#include "../Demon/gestionDepannage.h"
#endif

pthread_mutex_t mutex_web;
pthread_mutex_t mutex_jpeg_buf;
pthread_mutex_t mutex_nb_client;


//Initialisation des mutex
void initMutex() {
	pthread_mutex_init(&mutex_web,NULL);
	pthread_mutex_init(&mutex_jpeg_buf,NULL);
	pthread_mutex_init(&mutex_nb_client,NULL);

	#ifdef DEBUG
		printf("DEBUG : Initialisation des mutex : [OK] \n");
	#endif
}

void P(pthread_mutex_t  * mutex){
	pthread_mutex_lock(mutex);
}

void V(pthread_mutex_t * mutex){
	pthread_mutex_unlock(mutex);
}

//#ifdef IHM 

// Fonction qui lance le thread IHMECOUTE
static void * lanceThreadIhmEcoute() {
 gestionIhmEcoute();
 return 0;
}

// Fonction qui cre un thread IHMECOUTE
void creerThreadIhmEcoute() {

	pthread_t tid;
	pthread_attr_t attr;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	#ifdef DEBUG
		printf("DEBUG : Cration du thread IHM ECOUTE: [OK] \n");
	#endif
	pthread_create(&tid, &attr, lanceThreadIhmEcoute,NULL);
}

// Fonction qui lance le thread IHM
static void * lanceThreadIhm() {
  	gestionIhm();

 return 0;
}

// Fonction qui cre un thread IHM
void creerThreadIhm() {

	pthread_t tid;
	pthread_attr_t attr;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	#ifdef DEBUG
		printf("DEBUG : Cration du thread IHM : [OK] \n");
	#endif
	pthread_create(&tid, &attr, lanceThreadIhm,NULL);
}


// Fonction qui lance le thread SON
static void * lanceThreadSon() {

	gestionSon(sounds[0]);

	 return 0;
}

// Fonction qui cre un thread SON
void creerThreadSon(){

	pthread_t tid;
	pthread_attr_t attr;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

	#ifdef DEBUG
		printf("DEBUG : Cration du thread SON : [OK] \n");
	#endif

	pthread_create(&tid, &attr, lanceThreadSon, NULL);
}

//#endif

// Fonction qui lance le thread SERIE
static void * lanceThreadSerie() {
	gestionSerie();
	return 0;
}

// Fonction qui cre un thread SERIE
void creerThreadSerie() {

	pthread_t tid;
	pthread_attr_t attr;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	#ifdef DEBUG
		printf("DEBUG : Cration du thread SERIE : [OK] \n");
	#endif
	pthread_create(&tid, &attr, lanceThreadSerie,NULL);
}

// Fonction qui lance le thread IRC
static void * lanceThreadIrc() {
  gestionIrc();

 return 0;
}

// Fonction qui cre un thread IRC
void creerThreadIrc() {

	pthread_t tid;
	pthread_attr_t attr;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	#ifdef DEBUG
		printf("DEBUG : Cration du thread IRC : [OK] \n");
	#endif
	pthread_create(&tid, &attr, lanceThreadIrc,NULL);
}

// Fonction qui lance le thread WEB

/*static void * lanceThreadWeb(void * arg) {

	int sd = *(int *)arg;
	free(arg);
	#ifdef DEBUG
	printf("socket de dialogue dans lanceThreadWeb : %d\n",sd);
	#endif
	gestionWeb(sd);

 return 0;
}

// Fonction qui cre un thread WEB
static void creerThreadWeb(int sock){

	pthread_t tid;
	pthread_attr_t attr;

	// Recuperation de la socket
	int *adnum = (int *)malloc(sizeof(int));
	*adnum = sock;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

	#ifdef DEBUG
		printf("DEBUG : Cration du thread Web : [OK] \n");
	#endif

	pthread_create(&tid, &attr, lanceThreadWeb, (void *)adnum);
}

// Fonction qui lance le serveur web
static void * lanceThreadServeurWeb() {
	gestionServeurWeb();
	return 0;
}

// Fonction qui cre le serveur web
void creerThreadServeurWeb() {

	pthread_t tid;
	pthread_attr_t attr;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	#ifdef DEBUG
		printf("DEBUG : Cration du serveur web : [OK] \n");
	#endif
	pthread_create(&tid, &attr, lanceThreadServeurWeb,NULL);
}
*/

// Fonction qui lance le thread Kinect
static void * lanceThreadKinect() {
	handleKinect();

 return 0;
}

// Fonction qui cre un thread Kinect
void creerThreadKinect() {

	pthread_t tid;
	pthread_attr_t attr;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	#ifdef DEBUG
		printf("DEBUG : Cration du thread Kinect : [OK] \n");
	#endif
	pthread_create(&tid, &attr, lanceThreadKinect,NULL);
}


/*static void * lanceThreadServeurImage() {
  gestionServeurImage();

 return 0;
}

// Fonction qui cre le serveur de gestion des images
void creerThreadServeurImage() {

	pthread_t tid;
	pthread_attr_t attr;

	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	#ifdef DEBUG
		printf("DEBUG : Cration du serveur de gestion des images : [OK] \n");
	#endif
	pthread_create(&tid, &attr, lanceThreadServeurImage,NULL);
}

// Fonction qui lance le thread de client image
static void * lanceThreadClientImage(void * arg) {
	int sd = *(int *)arg;
	free(arg);
	#ifdef DEBUG
	printf("socket de dialogue dans lanceThreadClientImage : %d\n",sd);
	#endif
	gestionClientImage(sd);
return 0;
}

// Fonction qui cre un thread client image
void creerThreadClientImage(int sock) {

	pthread_t tid;
	pthread_attr_t attr;
	
	// Recuperation de la socket
	int *adnum = (int *)malloc(sizeof(int));
	*adnum = sock;
	
	#ifdef DEBUG
	printf("socket de dialogue dans creerThreadClientImage : %d %d\n",sock, *adnum);
	#endif
	// Initialisation de l'attribut
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
	#ifdef DEBUG
		printf("DEBUG : Cration du thread du client image : [OK] \n");
	#endif
	pthread_create(&tid, &attr, lanceThreadClientImage,(void *)adnum);
}*/

